// Copyright (c) 2016, 2018, 2022, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
//

package vulnerabilityscanning

import (
	"github.com/oracle/oci-go-sdk/v56/common"
)

// CveDetails Details on a CVE
type CveDetails struct {

	// CVE ID
	CveReference *string `mandatory:"true" json:"cveReference"`

	// Vulnerability title
	Title *string `mandatory:"true" json:"title"`

	// CVSS 3 Score
	Cvss3 *string `mandatory:"true" json:"cvss3"`

	// Date/time the CVE was published
	TimePublished *common.SDKTime `mandatory:"true" json:"timePublished"`

	// Date/time the CVE was last modified
	TimeUpdated *common.SDKTime `mandatory:"true" json:"timeUpdated"`

	// CVE description
	Description *string `mandatory:"false" json:"description"`

	// ID of related CVE, if applicable
	RelatedCveReference *string `mandatory:"false" json:"relatedCveReference"`
}

func (m CveDetails) String() string {
	return common.PointerString(m)
}
