// Copyright (c) 2016, 2018, 2022, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
//

package vulnerabilityscanning

// HostPortScanResultSortByEnum Enum with underlying type: string
type HostPortScanResultSortByEnum string

// Set of constants representing the allowable values for HostPortScanResultSortByEnum
const (
	HostPortScanResultSortByTimeStarted            HostPortScanResultSortByEnum = "timeStarted"
	HostPortScanResultSortByTimeFinished           HostPortScanResultSortByEnum = "timeFinished"
	HostPortScanResultSortByOpenPortCount          HostPortScanResultSortByEnum = "openPortCount"
	HostPortScanResultSortByHighestProblemSeverity HostPortScanResultSortByEnum = "highestProblemSeverity"
	HostPortScanResultSortByTimeCompleted          HostPortScanResultSortByEnum = "timeCompleted"
)

var mappingHostPortScanResultSortBy = map[string]HostPortScanResultSortByEnum{
	"timeStarted":            HostPortScanResultSortByTimeStarted,
	"timeFinished":           HostPortScanResultSortByTimeFinished,
	"openPortCount":          HostPortScanResultSortByOpenPortCount,
	"highestProblemSeverity": HostPortScanResultSortByHighestProblemSeverity,
	"timeCompleted":          HostPortScanResultSortByTimeCompleted,
}

// GetHostPortScanResultSortByEnumValues Enumerates the set of values for HostPortScanResultSortByEnum
func GetHostPortScanResultSortByEnumValues() []HostPortScanResultSortByEnum {
	values := make([]HostPortScanResultSortByEnum, 0)
	for _, v := range mappingHostPortScanResultSortBy {
		values = append(values, v)
	}
	return values
}
