// Copyright (c) 2016, 2018, 2022, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
//

package vulnerabilityscanning

// OperationTypeEnum Enum with underlying type: string
type OperationTypeEnum string

// Set of constants representing the allowable values for OperationTypeEnum
const (
	OperationTypeCreateHostScanRecipe      OperationTypeEnum = "CREATE_HOST_SCAN_RECIPE"
	OperationTypeUpdateHostScanRecipe      OperationTypeEnum = "UPDATE_HOST_SCAN_RECIPE"
	OperationTypeDeleteHostScanRecipe      OperationTypeEnum = "DELETE_HOST_SCAN_RECIPE"
	OperationTypeCreateHostScanTarget      OperationTypeEnum = "CREATE_HOST_SCAN_TARGET"
	OperationTypeUpdateHostScanTarget      OperationTypeEnum = "UPDATE_HOST_SCAN_TARGET"
	OperationTypeDeleteHostScanTarget      OperationTypeEnum = "DELETE_HOST_SCAN_TARGET"
	OperationTypeCreateContainerScanRecipe OperationTypeEnum = "CREATE_CONTAINER_SCAN_RECIPE"
	OperationTypeUpdateContainerScanRecipe OperationTypeEnum = "UPDATE_CONTAINER_SCAN_RECIPE"
	OperationTypeDeleteContainerScanRecipe OperationTypeEnum = "DELETE_CONTAINER_SCAN_RECIPE"
	OperationTypeCreateContainerScanTarget OperationTypeEnum = "CREATE_CONTAINER_SCAN_TARGET"
	OperationTypeUpdateContainerScanTarget OperationTypeEnum = "UPDATE_CONTAINER_SCAN_TARGET"
	OperationTypeDeleteContainerScanTarget OperationTypeEnum = "DELETE_CONTAINER_SCAN_TARGET"
)

var mappingOperationType = map[string]OperationTypeEnum{
	"CREATE_HOST_SCAN_RECIPE":      OperationTypeCreateHostScanRecipe,
	"UPDATE_HOST_SCAN_RECIPE":      OperationTypeUpdateHostScanRecipe,
	"DELETE_HOST_SCAN_RECIPE":      OperationTypeDeleteHostScanRecipe,
	"CREATE_HOST_SCAN_TARGET":      OperationTypeCreateHostScanTarget,
	"UPDATE_HOST_SCAN_TARGET":      OperationTypeUpdateHostScanTarget,
	"DELETE_HOST_SCAN_TARGET":      OperationTypeDeleteHostScanTarget,
	"CREATE_CONTAINER_SCAN_RECIPE": OperationTypeCreateContainerScanRecipe,
	"UPDATE_CONTAINER_SCAN_RECIPE": OperationTypeUpdateContainerScanRecipe,
	"DELETE_CONTAINER_SCAN_RECIPE": OperationTypeDeleteContainerScanRecipe,
	"CREATE_CONTAINER_SCAN_TARGET": OperationTypeCreateContainerScanTarget,
	"UPDATE_CONTAINER_SCAN_TARGET": OperationTypeUpdateContainerScanTarget,
	"DELETE_CONTAINER_SCAN_TARGET": OperationTypeDeleteContainerScanTarget,
}

// GetOperationTypeEnumValues Enumerates the set of values for OperationTypeEnum
func GetOperationTypeEnumValues() []OperationTypeEnum {
	values := make([]OperationTypeEnum, 0)
	for _, v := range mappingOperationType {
		values = append(values, v)
	}
	return values
}
